<?php
ini_set('pcre.jit', '0');
    function cmp_by_filesize($a, $b) {
        return $b["filesize"] - $a["filesize"];
        //return $a["filesize"] - $b["filesize"];
    }    
    
class Sorter {
	private $workdir = false;

	public function __construct($workdir) {
		$this->workdir = trim($workdir);

		$this->process_CRC_list();
	}

	private function process_CRC_list() {
		$stream = new SplFileObject($this->workdir."DUPLICATE_CRCS.txt"); 
		
		while (!$stream->eof()) {
   			$crc = trim($stream->fgets());
   			$tmp = substr(md5($crc), 0, 3)."_";
            
            $candidates_array = array();

            if (is_readable($this->workdir.$tmp."CRC_IMAGEID.txt")) {
                $stream_two = new SplFileObject($this->workdir.$tmp."CRC_IMAGEID.txt");

                while (!$stream_two->eof()) {
                    $line = $stream_two->fgets();

                    if (strpos($line, $crc) !== false) {
                        $line_array = explode("%BREAKPOINT%", $line);
					
                        $candidates_array[] = array(
                            "id" => $line_array[1],
                            "pixels" => $line_array[2],
                            "filesize" => $line_array[3]
                        );
                    }
                }

                $stream_two = null;
            }    
            
			usort($candidates_array, "cmp_by_filesize");

			foreach ($candidates_array as $key => $candidate) {
				if ($key === 0) {
					$this->write("ORIGINALS.txt", $candidate["id"]);
				} else {
					$this->write("DUPLICATES.txt", $candidate["id"]."%BREAKPOINT%".$candidates_array[0]["id"]);
				}
			}
   		}

   		$stream = null;
   	}	

	private function write($name, $string) {
		file_put_contents($this->workdir.$name, $string."\n", FILE_APPEND);
	}
}

$Sorter = new Sorter($argv[1]);
